import flash.utils.Dictionary;

import mx.collections.ArrayCollection;
import mx.controls.Alert;
import mx.controls.CheckBox;
import mx.controls.listClasses.ListBase;

import mx.events.FlexEvent;
import mx.events.ListEvent;
import flash.events.MouseEvent;

[Bindable]
public var provider:ArrayCollection = new ArrayCollection([new Data('A'), new Data('B'), 
                                                           new Data('C'), new Data('D'),
                                                           new Data('E'), new Data('F'),
                                                           new Data('G'), new Data('H'), 
                                                           new Data('I'), new Data('J'),
                                                           new Data('K'), new Data('L')])

private var previousSelected:Array = []
private var captureSelected:Array = []
public var listCreationComplete:Function = function ():void {
  
  addEventListener(MouseEvent.MOUSE_DOWN, listCaptureDown, true)
  addEventListener(MouseEvent.MOUSE_DOWN, listBubbleDown, false)
  
}

public var listChange:Function = function (event:ListEvent):void {
  
  for each (var previous:* in previousSelected) {
    if (previous.hasOwnProperty('selected')) {
      previous.selected = false
    }
  }
  
  var listBase:ListBase = event.currentTarget as ListBase
  var currentSelected:Array = listBase.selectedItems
  for each (var current:* in currentSelected) {
    if (current.hasOwnProperty('selected')) {
      current.selected = true
    }
  }
  
  previousSelected = currentSelected
  
  listBase.invalidateList()
}

public var listCaptureDown:Function = function (event:MouseEvent):void {
  
  if (event.target is CheckBox) {
    var dataCheckbox:CheckBox = event.target as CheckBox
    var checkboxParent:* = dataCheckbox.parent
    var realData:* = checkboxParent.data
    
    captureSelected = list.selectedItems
    // In capture state, checkbox must inverse value from bubble because checkbox doesn't receive click yet
    if (dataCheckbox.selected) {
      captureSelected = captureSelected.filter(function callback(item:*, index:int, array:Array):Boolean {
        return item != realData
      }, realData)
    } else {
      captureSelected.push(realData)
    }
    
  }
  
}

public var listBubbleDown:Function = function (event:MouseEvent):void {
  
  if (event.target is CheckBox) {
    list.selectedItems = captureSelected
  }
  
}
